﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices.Sensors;

namespace AcceleromerDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        private Accelerometer accelerometer;
        // Constructor
        public MainPage()
        {
            InitializeComponent();

            accelerometer = new Accelerometer();
            accelerometer.ReadingChanged += new EventHandler<AccelerometerReadingEventArgs>(accelerometer_ReadingChanged);
            accelerometer.Start();
        }

        void accelerometer_ReadingChanged(object sender, AccelerometerReadingEventArgs e)
        {
            if (accelerometer != null)
            {
                this.Dispatcher.BeginInvoke(() =>
                {
                    statusTextBlock.Text = accelerometer.State.ToString();
                    XTextBlock.Text = e.X.ToString("0.00");
                    YTextBlock.Text = e.Y.ToString("0.00");
                    ZTextBlock.Text = e.Z.ToString("0.00");
                });
            }
        }
    }
}