﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Notification;
using System.Diagnostics;
using System.IO;
using System.Text;

namespace PushDemo
{
    public partial class MainPage : PhoneApplicationPage
    {

        private HttpNotificationChannel channel;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            StartChannel();
        }

        private void StartChannel()
        {
            channel = HttpNotificationChannel.Find("Alerts");

            if (channel == null)
            {
                channel = new HttpNotificationChannel("Alerts", "CD10");
                AddDelegates();

                channel.Open();
            }
            else
            {
                AddDelegates();

                EnsureChannelBind();
            }
        }

        private void AddDelegates()
        {
            channel.ChannelUriUpdated += new EventHandler<NotificationChannelUriEventArgs>(channel_ChannelUriUpdated);
            channel.ErrorOccurred += new EventHandler<NotificationChannelErrorEventArgs>(channel_ErrorOccurred);
            channel.ShellToastNotificationReceived += new EventHandler<NotificationEventArgs>(channel_ShellToastNotificationReceived);
            channel.HttpNotificationReceived += new EventHandler<HttpNotificationEventArgs>(channel_HttpNotificationReceived);
        }

        void channel_HttpNotificationReceived(object sender, HttpNotificationEventArgs e)
        {
            string text = new StreamReader(e.Notification.Body, Encoding.UTF8).ReadToEnd();
            this.Dispatcher.BeginInvoke(() =>
            {
                MessageBox.Show(text);
            });
        }

        void channel_ShellToastNotificationReceived(object sender, NotificationEventArgs e)
        {
            string text = e.Collection["Text1"] + " " + e.Collection["Text2"];
            this.Dispatcher.BeginInvoke(() =>
            {
                MessageBox.Show(text);
            });
        }

        void channel_ErrorOccurred(object sender, NotificationChannelErrorEventArgs e)
        {
            if (e.ErrorType == ChannelErrorType.PowerLevelChanged)
            {
                ChannelPowerLevel level = (ChannelPowerLevel)e.ErrorAdditionalData;
                
                // TODO: batteria
            }

            MessageBox.Show(e.Message);
            ContentPanel.Background = new SolidColorBrush(Colors.Red);
        }

        void channel_ChannelUriUpdated(object sender, NotificationChannelUriEventArgs e)
        {
            EnsureChannelBind();
        }

        private void EnsureChannelBind()
        {
            if (!this.channel.IsShellToastBound)
                this.channel.BindToShellToast();
            if (!this.channel.IsShellTileBound)
                this.channel.BindToShellTile();

            this.Dispatcher.BeginInvoke(() => ContentPanel.Background = new SolidColorBrush(Colors.Green));

            Debug.WriteLine(channel.ChannelUri);
        }
    }
}