﻿using System;
using System.Net;

namespace PushServerDemo
{
    public static class EnumExtensions
    {
        public static bool TryParse<TEnum>(string name, out TEnum result)
            where TEnum : struct
        {
#if SILVERLIGHT
            result = (TEnum)System.Enum.Parse(typeof(TEnum), name, true);

            return true;
#else
            return System.Enum.TryParse<TEnum>(name, out result);
#endif
        }

    }

    public static class GuidExtensions
    {
        public static bool TryParse(string input, out Guid result)
        {
#if SILVERLIGHT
            result = new System.Guid(input);

            return true;
#else
            return System.Guid.TryParse(input, out result);
#endif
        }
    }
}
