﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using Microsoft.Phone;
using System.Windows.Media.Imaging;

namespace TasksDemo
{
    public partial class MainPage : PhoneApplicationPage
    {

        private PhotoChooserTask pct;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            //InitPhotoChooser();
        }

        private void camera_Click(object sender, RoutedEventArgs e)
        {
            CameraCaptureTask cct = new CameraCaptureTask();
            cct.Completed += new EventHandler<PhotoResult>(CameraCaptureTask_Completed);
            cct.Show();
        }

        void CameraCaptureTask_Completed(object sender, PhotoResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                WriteableBitmap bmp = PictureDecoder.DecodeJpeg(e.ChosenPhoto);
                //BitmapImage image = new BitmapImage();
                //image.SetSource(e.ChosenPhoto);
                //WriteableBitmap bmp = new WriteableBitmap(image);
            }
        }

        private void emailChoose_Click(object sender, RoutedEventArgs e)
        {
            EmailAddressChooserTask ect = new EmailAddressChooserTask();
            ect.Completed += new EventHandler<EmailResult>(EmailAddressChooserTask_Completed);
            ect.Show();
        }

        void EmailAddressChooserTask_Completed(object sender, EmailResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                MessageBox.Show(e.Email);
            }
        }

        private void phoneNumberChoose_Click(object sender, RoutedEventArgs e)
        {
            PhoneNumberChooserTask pnc = new PhoneNumberChooserTask();
            pnc.Show();
        }

        private void photoChooser_Click(object sender, RoutedEventArgs e)
        {
            InitPhotoChooser();
            pct.Show();
        }

        private void InitPhotoChooser()
        {
            pct = new PhotoChooserTask();
            pct.Completed += new EventHandler<PhotoResult>(PhotoChooserTask_Completed);
            pct.ShowCamera = true;
            pct.PixelWidth = 200;
            pct.PixelHeight = 200;
        }

        void PhotoChooserTask_Completed(object sender, PhotoResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
            }
        }

        private void saveEmail_Click(object sender, RoutedEventArgs e)
        {
            SaveEmailAddressTask set = new SaveEmailAddressTask();
            set.Email = "cristian@aspitalia.com";
            set.Show();
        }

        private void savePhone_Click(object sender, RoutedEventArgs e)
        {
            SavePhoneNumberTask snt = new SavePhoneNumberTask();
            snt.PhoneNumber = "1234566";
            snt.Show();
        }

        private void emailCompose_Click(object sender, RoutedEventArgs e)
        {
            EmailComposeTask ect = new EmailComposeTask();
            ect.Subject = "Oggetto";
            ect.To = "daniele@aspitalia.com";
            ect.Body = "Forza Inter!";
            ect.Show();
        }

        private void marketplace_Click(object sender, RoutedEventArgs e)
        {
            MarketplaceHubTask mth = new MarketplaceHubTask();
            mth.ContentType = MarketplaceContentType.Applications;
            mth.Show();
        }

        private void mediaPlayer_Click(object sender, RoutedEventArgs e)
        {
            MediaPlayerLauncher mpl = new MediaPlayerLauncher();
            mpl.Controls = MediaPlaybackControls.Pause;
            mpl.Media = new Uri("test.wmv");
            mpl.Show();
        }

        private void search_Click(object sender, RoutedEventArgs e)
        {
            SearchTask st = new SearchTask();
            st.SearchQuery = "ASPItalia.com";
            st.Show();
        }

        private void smsCompose_Click(object sender, RoutedEventArgs e)
        {
            SmsComposeTask sct = new SmsComposeTask();
            sct.Body = "Forza inter!";
            sct.Show();
        }

        private void webBroser_Click(object sender, RoutedEventArgs e)
        {
            WebBrowserTask wbt = new WebBrowserTask();
            wbt.URL = "http://www.aspitalia.com";
            wbt.Show();
        }
    }
}